package cz.muni.fi.pb162.runtimeexception;

/**
 * Základnú teóriu ohľadom výnimiek nájdete v balíku exception v triede Demo
 */
public class Demo {
    public static void main(String[] args) {

        System.out.println("Returned value=" + tryfinally());
        //  try {
//            creatingPersonCatchException();
//        } catch(MissingNameException mne) {
//            System.out.println("Exception caught");
//            mne.printStackTrace();
//        }
        // Behové výnimky reprezentujú chyby v programe
        // Sú potomkami triedy RuntimeException
        // Nie sú sledované prekladačom
        // Príklad vlastnej behovej výnimky je trieda MissingNameException
        // Príklad použitia výnimiek nájdete v triede Person v konštruktore

        // príklad zachytenej behovej výnimky
        //creatingPersonCatchException();

        // v metóde nájdete ukážku použitia bloku finally
        // táto metóda vyhodí výnimku a ukončí program
        //creatingPersonWithFinallyBlock();
    }

    public static int tryfinally() {
        try {
            return 5;
        } finally {
            return 4;
        }
    }

    private static void creatingPersonCatchException()
            throws MissingNameException {
        try {
            System.out.println("Snažím sa vytvoriť osobu s řádnou hodnotou jako jménem!");
            Person pavel = new Person(null);
            System.out.println("Po (řádném) vytvoření osoby");
        //} catch (MissingNameException ex) {
        //    System.out.println("Bola vyhodená výnimka MissingNameException. Chyba: " + ex.getMessage());
        } catch (IllegalArgumentException ex) {
            System.out.println("Bola vyhodená výnimka IllegalArgumentException. Chyba: " + ex.getMessage());
        }
        System.out.println("Po bloku try - provede se!");
        try {
            System.out.println("Snažím sa vytvoriť osobu s prázdnym Stringom ako menom!");
            Person peter = new Person("");
            System.out.println("Toto sa nevypíše!");
        // ak sa telo catch bloku opakuje môžeme využiť takýto skrátený zápis
        } catch (MissingNameException | IllegalArgumentException ex) {
            System.out.println("Použili sme nevhodnú hodnotu pre meno osoby! Chyba: " + ex.getMessage());
        }
        System.out.println("Po druhém bloku try - provede se!");

    }

    // blok finally obvykle nasleduje catch bloky (môže byť aj priamo za try blokom)
    // kód v bloku finally sa vykoná vždy (ak je výnimka zachytená, nezachytená alebo ak nebola vyhodená)
    private static void creatingPersonWithFinallyBlock()
            throws MissingNameException {
        try {
            System.out.println("Snažím sa vytvoriť osobu s hodnotou null ako menom!");
            Person peter = new Person(null);
            System.out.println("Toto sa nevypíše!");
        } catch (MissingNameException ex) {
            System.out.println("Bola vyhodená výnimka MissingNameException. Chyba: " + ex.getMessage());
        } finally { // blok finally sa vykoná aj keď výnimka bola zachytená
            System.out.println("Blok finally sa vykoná vždy!");
        }

        try {
            System.out.println("Snažím sa vytvoriť osobu s prázdnym Stringom ako menom!");
            Person peter = new Person("");
            System.out.println("Toto sa nevypíše!");
        } finally { // blok finally sa vykoná aj keď výnimka nebola zachytená
            System.out.println("Blok finally sa vykoná vždy aj keď sa výnimka nezachytí!");
        }
    }
}
